import { acceptHMRUpdate, defineStore } from 'pinia';

interface BasicUserInfo {
  [key: string]: any;
  /**
   * 用户名
   */
  account: string;
  /**
   * 用户id
   */
  accountid: string;
  /**
   * 部门
   */
  bm: null | string;
  /**
   * 部门id
   */
  bmid: number;
  /**
   * 角色列表
   */
  grouplist: string;
  /**
   * 昵称
   */
  nickname: string;
  /**
   * 权限列表
   */
  popedom: string;
  /**
   * 过期时间
   */
  timeout: number;
  /**
   * 令牌
   */
  token: string;
  /**
   * 职员id
   */
  workerid: string;
  /**
   * 用户id
   */
  workeruserid: string;
}

interface AccessState {
  /**
   * 用户信息
   */
  userInfo: BasicUserInfo | null;
  /**
   * 用户角色
   */
  userRoles: string[];
}

/**
 * @zh_CN 用户信息相关
 */
export const useUserStore = defineStore('core-user', {
  state: (): AccessState => ({
    userInfo: null,
    userRoles: [],
  }),
  getters: {
    // 是否经销商/代理商
    isDLS(): boolean {
      return this.userRoles.includes('49');
    },
    // 是否管理员
    isSuperAdmin(): boolean {
      return this.userRoles.includes('1');
    },
    // 是经销商，但不是管理员
    isDLSNotAdmin(): boolean {
      return this.isDLS && !this.isSuperAdmin;
    },
  },
  actions: {
    setUserInfo(userInfo: BasicUserInfo | null) {
      // 设置用户信息
      this.userInfo = userInfo;
      // 设置角色信息
      const roles = userInfo?.grouplist.split(',') ?? [];
      this.setUserRoles(roles);
    },
    setUserRoles(roles: string[]) {
      this.userRoles = roles;
    },
  },
});

// 解决热更新问题
const hot = import.meta.hot;
if (hot) {
  hot.accept(acceptHMRUpdate(useUserStore, hot));
}
